﻿using System;
using System.Collections.Generic;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Linq;

namespace TreeMap_SL
{
    public class Folder : IDiskItem
    {
        private string _name;
        private bool _isSelected;
        private IEnumerable<IDiskItem> _children;

        public Folder(string name, IEnumerable<IDiskItem> children)
        {
            this._name = name;
            this._children = children;
        }

        public string Name
        {
            get
            {
                return _name;
            }
        }

        public long Size
        {
            get
            {
                return this.Children.Sum(child => child.Size);
            }
        }

        public IEnumerable<IDiskItem> Children
        {
            get
            {
                return _children;
            }
        }

        public bool IsSelected
        {
            get
            {
                return _isSelected;
            }
            set
            {
                this._isSelected = value;
            }
        }
    }
}
